part of model_notifier;

/// Gets the key for the date associated with [key].
///
/// If [time] is specified, the key at that time is obtained.
String dailyKey(String key, [DateTime? time]) {
  time ??= DateTime.now();
  return "$key:${time.format("yyyyMMdd")}";
}

/// Gets the key for the week associated with [key].
///
/// If [time] is specified, the key at that time is obtained.
String weeklyKey(String key, [DateTime? time]) {
  time ??= DateTime.now();
  return "$key:${time.format("yyyyww")}";
}

/// Gets the key of the month associated with [key].
///
/// If [time] is specified, the key at that time is obtained.
String monthlyKey(String key, [DateTime? time]) {
  time ??= DateTime.now();
  return "$key:${time.format("yyyyMM")}";
}

/// Gets the key for the year associated with [key].
///
/// If [time] is specified, the key at that time is obtained.
String yearlyKey(String key, [DateTime? time]) {
  time ??= DateTime.now();
  return "$key:${time.format("yyyy")}";
}
